#ifndef NSRPC_SYSTEMSERVICEHANDLER_H
#define NSRPC_SYSTEMSERVICEHANDLER_H

#include <nsrpc/p2p/PeerId.h>
#include <nsrpc/p2p/detail/P2pAddress.h>
#include <boost/noncopyable.hpp>

namespace nsrpc
{

namespace detail
{

/** @addtogroup p2p
* @{
*/

/**
 * @class SystemServiceHandler
 *
 * P2P system service handler
 */
class SystemServiceHandler : public boost::noncopyable
{
public:
    virtual ~SystemServiceHandler() {}

    ///  
    virtual bool authenticate(PeerId peerId,
        const std::string& sessionPassword, srpc::UInt32 sessionKey) = 0;

    /**
     * ο Ǿ Ͽ.
     * @return ο Ǿ  true.
     */
    virtual bool peerConnected(PeerId peerId,
        const ACE_INET_Addr& targetAddress,
        const RAddresses& peerAddresses) = 0;

    /**
     * Ǿ  Ͽ.
     */
    virtual void peerDisconnected(PeerId peerId) = 0;

    /// ش Ǿ  õѴ.
    virtual void connectToNewPeer(PeerId peerId,
        const Addresses& peerAddresses) = 0;

    /// peerId ο ȣƮ Ǿ
    virtual void hostMigrated(PeerId peerId) = 0;

    /// P2P Ӽ Ѵ
    virtual void setP2pProperty(const RP2pProperty& p2pProperty) = 0;

    ///   ؾ ϴ°?
    virtual bool shouldConnectReversal(const ACE_INET_Addr& address) const = 0;

    /// ȣƮ ߴ°?
    virtual bool isHostConnected() const = 0;
};

/** @} */ // addtogroup p2p

} // namespace detail

} // namespace nsrpc

#endif // NSRPC_SYSTEMSERVICEHANDLER_H
