#ifndef SRPC_RPCEVENT_H
#define SRPC_RPCEVENT_H

#include "ReceivingFunctors.h"
//#include <boost/thread/mutex.hpp>
#include "Mutex.h"
#include <boost/noncopyable.hpp>

namespace srpc {

class IStream;

/** @addtogroup RpcReceiving
* @{
*/

/**
 * @class RpcEvent
 *
 * rpc event(response)
 * - Ƽ带    ٸ 尡 ÿ  ̺Ʈ
 *   óϴ 찡 ߻ϹǷ lock . ġũ    ̰
 *    .
 */
class RpcEvent : public boost::noncopyable
{
public:
    RpcEvent(ReceivingFunctor& functor) :
        unmarshalDispatcher_(functor) {}

    template <class RpcClass>
    void dispatch(RpcClass& rpcClass, IStream& istream,
        const void* rpcHint = 0) {
        //boost::mutex::scoped_lock lock(monitor_);
        ScopedLock<LightMutex> lock(monitor_);

        unmarshalDispatcher_(istream);
        unmarshalDispatcher_.call(&rpcClass, rpcHint);
    }
private:
    ReceivingFunctor& unmarshalDispatcher_;

    //boost::mutex monitor_;
    LightMutex monitor_;
};

/** @} */ // addtogroup RpcReceiving

} // namespace srpc

#endif // SRPC_RPCEVENT_H
