#ifndef NSRPC_PACKETSEEDEXCHANGER_H
#define NSRPC_PACKETSEEDEXCHANGER_H

#include "detail/rpc_interface/SecurityService.h"
#include "config/config.h"
#include <srpc/RpcForwarder.h>
#include <srpc/RpcReceiver.h>

class ACE_Recursive_Thread_Mutex;

namespace nsrpc
{

class PacketCoder;
class SessionRpcNetwork;

/**
 * @class PacketSeedExchanger
 * Ŭ̾Ʈ/  Ŷ ȣȭ õ  ȯѴ
 */
class NSRPC_API PacketSeedExchanger :
    protected srpc::RpcReceiver, protected srpc::RpcForwarder,
    public RpcSecurityService
{
    DECLARE_SRPC_EVENT_DISPATCHER(PacketSeedExchanger);
public:
    // = Factory
    static PacketSeedExchanger* createForServer();

    static PacketSeedExchanger* createForClient();
public:
    PacketSeedExchanger();

    /// @internal
    void initialize(PacketCoder* packetCoder,
        SessionRpcNetwork* rpcNetwork, ACE_Recursive_Thread_Mutex* lock);

    /// Ŭ̾Ʈ     ʱ õ尪 ȯѴ
    virtual void exchangeFirstSeed() = 0;

    ///  ֱ õ尪 ȯѴ
    virtual void exchangeNextSeed() = 0;
protected:
    PacketCoder& getPacketCoder() {
        return *packetCoder_;
    }

    ACE_Recursive_Thread_Mutex& getLock() {
        return *lock_;
    }
private:
    PacketCoder* packetCoder_;
    ACE_Recursive_Thread_Mutex* lock_;
};

} // namespace nsrpc

#endif // !defined(NSRPC_PACKETSEEDEXCHANGER_H)
