#ifndef SRPC_OSTREAM_H
#define SRPC_OSTREAM_H

#include "Types.h"
#include "StringTypes.h"
#include "utility/Bits.h"
#include <boost/utility.hpp>
#include <string>
#include <cassert>

namespace srpc {

/** @addtogroup serialization
* @{
*/

/**
 * @class OStream
 *
 * Output stream.
 * - CAUTION:  Ÿ  Ʈ Ѵ
 */
class OStream : public boost::noncopyable
{
public:
    virtual ~OStream() {}

    /// 64Ʈ ȣ   Ʈۿ Ѵ
    virtual void write(UInt64 value, int bitCount = Bits<UInt64>::size) = 0;

    /// 32Ʈ ȣ   Ʈۿ Ѵ
    virtual void write(UInt32 value, int bitCount = Bits<UInt32>::size) = 0;

    /// 16Ʈ ȣ   Ʈۿ Ѵ
    virtual void write(UInt16 value, int bitCount = Bits<UInt16>::size) = 0;

    /// 8Ʈ ȣ   Ʈۿ Ѵ
    virtual void write(UInt8 value, int bitCount = Bits<UInt8>::size) = 0;

    /// ο︰  Ʈۿ Ѵ
    virtual void write(bool value, int bitCount = Bits<bool>::size) = 0;

    /**
     * 64Ʈ ȣ ִ  Ÿ Ʈۿ Ѵ
     * @param bitCount  Ʈ . 2Ʈ ̻̾ Ѵ
     */
    virtual void write(Int64 value, int bitCount = Bits<Int64>::size) = 0;

    /**
    * 32Ʈ ȣ ִ  Ÿ Ʈۿ Ѵ
    * @param bitCount  Ʈ . 2Ʈ ̻̾ Ѵ
    */
    virtual void write(Int32 value, int bitCount = Bits<Int32>::size) = 0;

    /**
     * 16Ʈ ȣ ִ  Ÿ Ʈۿ Ѵ
     * @param bitCount  Ʈ . 2Ʈ ̻̾ Ѵ
     */
    virtual void write(Int16 value, int bitCount = Bits<Int16>::size) = 0;

    /**
     * 8Ʈ ȣ ִ  Ÿ Ʈۿ Ѵ
     * @param bitCount  Ʈ . 2Ʈ ̻̾ Ѵ
     */
    virtual void write(Int8 value, int bitCount = Bits<Int8>::size) = 0;

    /**
     * 32Ʈ ȣ ִ ε Ҽ Ÿ Ʈۿ Ѵ
     * @param bitCount  Ʈ . 2Ʈ ̻̾ Ѵ
     */
    virtual void write(Float32 value, int bitCount = Bits<Int32>::size) = 0;

    /// ִ maxLength  ڿ Ʈۿ Ѵ
    virtual void write(const String& value, size_t maxLength,
        int sizeBitCount) = 0;

    /// ִ maxLength  ڿ Ʈۿ Ѵ
    virtual void write(const WString& value, size_t maxLength,
        int sizeBitCount) = 0;

    /**
     * raw buffer Ʈۿ Ѵ
     * @param buffer raw buffer
     * @param length  Ʈ(USHRT_MAX  ۰ų ƾ Ѵ)
     */
    virtual void write(const void* buffer, UInt16 length) = 0;

    /// е ߰Ͽ Ʈ  Ѵ
    virtual void align() = 0;

    /**
     * Ʈ Ʈ ʱȭѴ
     * @param resetBuffer ۸ ʱȭ ΰ?
     */
    virtual void reset(bool resetBuffer) = 0;

    ///   ũ(Ʈ ) ´
    virtual int getTotalBitCount() const = 0;

    ///   ũ(Ʈ ) ´
    virtual int getTotalSize() const = 0;
};

/** @} */ // addtogroup serialization

} // namespace srpc

#endif // SRPC_OSTREAM_H
